#include <cstdio>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <iostream>
#define SIZE(x) ((int) (x).size())
#define REP(i, n) for (int i = 0; i < (int) (n); ++i)
using namespace std;

inline void Inv() {
	printf("INV\n");
}

inline void Push(int x) {
	if (x >= 0)
		printf("NUM %d\n", x);
	else {
		Push(-x);
		Inv();
	}
}

inline void Pop() {
	printf("POP\n");
}

inline void Dup() {
	printf("DUP\n");
}

inline void Swp() {
	printf("SWP\n");
}

inline void Add() {
	printf("ADD\n");
}

inline void Sub() {
	printf("SUB\n");
}

inline void Mul() {
	printf("MUL\n");
}

inline void Div() {
	printf("DIV\n");
}

inline void End() {
	printf("END\n");
}

inline void Copy(int x) {
	REP(i, x - 1)
		Dup();
}

int main() {
	int n;
	while (scanf("%d", &n), n) {
		vector<int> X(n), Y(n);
		REP(i, n)
			scanf("%d%d", &X[i], &Y[i]);

		if (n == 1) {
			Pop();
			Push(Y[0]);
		} else {
			Copy(n);
			Push(0);
			REP(i, n) {
				Swp();
				Copy(n - 1);
				Push(Y[i]);
				REP(j, n) if (j != i) {
					Swp();
					Push(X[j]);
					Sub();
					Push(X[i] - X[j]);
					Div();
					Mul();
				}
				Add();
			}
		}

		End();
		printf("\n");
	}
}
